osl::rating::AttackKing8 Class Reference

`#include <king8.h>`

Inheritance diagram for osl::rating::AttackKing8:

## Public Member Functions

| AttackKing8 (Ptype s, Ptype t, bool ss, int attack, int defense)
bool | match (const NumEffectState &state, Move move, const RatingEnv &env) const
Public Member Functions inherited from osl::rating::Feature
| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Static Private Member Functions

static const std::string | name (Ptype self, Ptype target, bool same)
Static Private Member Functions inherited from osl::rating::CountEffect2
static std::pair< int, int > | count (const NumEffectState &state, Square position, const RatingEnv &env)
static std::string | name (int attack, int defense)
static int | index (const NumEffectState &state, Square position, const RatingEnv &env)

## Private Attributes

Ptype | self
Ptype | target
bool | same
Private Attributes inherited from osl::rating::CountEffect2
int | attack
int | defense

## Additional Inherited Members

Private Member Functions inherited from osl::rating::CountEffect2
| CountEffect2 (int a, int d)
bool | match (const NumEffectState &state, Square position, const RatingEnv &env) const
Static Private Attributes inherited from osl::rating::CountEffect2
static const int | Max = 2

## Detailed Description

Definition at line 14 of file std/osl/rating/feature/king8.h.

## Constructor & Destructor Documentation

## AttackKing8()

osl::rating::AttackKing8::AttackKing8 | ( | Ptype | s,
|  | Ptype | t,
|  | bool | ss,
|  | int | attack,
|  | int | defense )

inline

Definition at line 20 of file std/osl/rating/feature/king8.h.

References osl::rating::CountEffect2::attack, osl::rating::CountEffect2::CountEffect2(), osl::rating::CountEffect2::defense, osl::rating::Feature::Feature(), name(), same, self, and target.

## Member Function Documentation

## match()

bool osl::rating::AttackKing8::match | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & | env ) const

inline virtual

Implements osl::rating::Feature.

Definition at line 25 of file std/osl/rating/feature/king8.h.

References osl::alt(), osl::Neighboring8Direct::findNearest(), osl::Move::from(), osl::NumEffectState::hasEffectByPiece(), osl::Move::isDrop(), osl::isPiece(), osl::Square::isPieceStand(), osl::SimpleState::kingSquare(), osl::rating::CountEffect2::match(), osl::Piece::owner(), osl::SimpleState::pieceAt(), osl::SimpleState::pieceOnBoard(), osl::Move::player(), osl::Move::ptype(), osl::Piece::ptype(), osl::Move::ptypeO(), same, self, target, osl::Move::to(), and osl::SimpleState::turn().

## name()

const std::string osl::rating::AttackKing8::name | ( | Ptype | self,
|  | Ptype | target,
|  | bool | same )

static private

Definition at line 5 of file king8_.cc.

References osl::Ptype_Table, same, self, and target.

Referenced by AttackKing8().

## Member Data Documentation

## same

bool osl::rating::AttackKing8::same

private

Definition at line 17 of file std/osl/rating/feature/king8.h.

Referenced by AttackKing8(), match(), and name().

## self

Ptype osl::rating::AttackKing8::self

private

Definition at line 16 of file std/osl/rating/feature/king8.h.

Referenced by AttackKing8(), match(), and name().

## target

Ptype osl::rating::AttackKing8::target

private

Definition at line 16 of file std/osl/rating/feature/king8.h.

Referenced by AttackKing8(), match(), and name().

The documentation for this class was generated from the following files:

- std/osl/rating/feature/king8.h
- king8_.cc